<?php
/*
Plugin Name: List Attachments Shortcode
Plugin URI: http://plugins.ten-321.com/list-attachments
Description: This plug-in simply adds a new shortcode that allows you to list all of a post's attachments inline.
Version: 0.1a
Author: Curtiss Grymala
Author URI: http://ten-321.com/
License: GPL2
*/

add_shortcode('list-attachments','la_listAttachments');

function la_listAttachments( $atts = array() ) {
	$r = '';
	$defaults = array(
		'type' => NULL,
		'orderby' => NULL,
		'groupby' => NULL,
		'order' => NULL,
		'before_list' => '',
		'after_list' => '',
		'opening' => '<ul class="attachment-list">',
		'closing' => '</ul>',
		'before_item' => '<li>',
		'after_item' => '</li>',
	);
	
	$atts = array_merge( $defaults, $atts );

	if( !empty( $atts['type'] ) ) {
		$types = explode( ',', str_replace( ' ', '', $atts['type'] ) );
	}
	else {
		$types = array();
	}
	
	global $post, $wp_query;

	$op = clone $post;
	$oq = clone $wp_query;
	
	$args = array(
		'post_type' => 'attachment',
		'numberposts' => -1,
		'post_status' => null,
		'post_parent' => $post->ID,
	);
	if( !empty( $atts['orderby'] ) ) {
		$args['orderby'] = $atts['orderby'];
	}
	if( !empty( $atts['order'] ) ) {
		$atts['order'] = ( in_array( $atts['order'], array('a','asc','ascending') ) ) ? 'asc' : 'desc';
		$args['order'] = $atts['order'];
	}
	if( !empty( $atts['groupby'] ) ) {
		$args['order_by'] = $atts['groupby'];
	}
	
	$attachments = get_posts($args);
	
	if( $attachments ) {
		$grouper = $atts['groupby'];
		$test = $attachments;
		$test = array_shift( $test );
		if( !property_exists( $test, $grouper ) ) {
			$grouper = 'post_' . $grouper;
		}
		$attlist = array();
		foreach( $attachments as $att ) {
			$key = ( !empty( $atts['groupby'] ) ) ? $att->$grouper : $att->ID;
			$key .= ( !empty( $atts['orderby'] ) ) ? $att->$atts['orderby'] : '';
			
			$attlink = wp_get_attachment_url( $att->ID );
			if( count( $types ) ) {
				foreach( $types as $t ) {
					if( substr( $attlink, (0- strlen( '.' . $t ) ) ) ) {
						$attlist[ $key ] = clone $att;
					}
				}
			}
			else {
				$attlist[ $key ] = clone $att;
			}
		}
	}
	if( $atts['order'] == 'asc' ) {
		ksort( $attlist );
	}
	else {
		krsort( $attlist );
	}
	
	if( count( $attlist ) ) {
		$open = false;
		$r = $atts['before_list'] . $atts['opening'];
		foreach( $attlist as $att ) {
			if( !empty( $atts['groupby'] ) && $current_group != $att->$grouper ) {
				if( $open ) {
					$r .= $atts['closing'] . $atts['after_item'];
					$open = false;
				}
				$r .= $atts['before_item'] . '<h3>' . $att->$grouper . '</h3>' . $atts['opening'];
				$open = true;
				$current_group = $att->$grouper;
			}
			$r .= $atts['before_item'] . '<a href="' . $attlink .'" title="View ' . apply_filters('the_title_attribute',$att->post_title) . '">' . apply_filters('the_title',$att->post_title) . '</a>' . $atts['after_item'];
		}
		if( $open ) {
			$r .= $atts['closing'] . $atts['after_item'];
		}
		$r .= $atts['closing'] . $atts['after_list'];
	}
	
	$wp_query = clone $oq;
	$post = clone $op;
	
	return $r;
}
?>